/*
 * touchtime.c 
 * BIG BROTHER TOUCHTIME PROGRAM
 * Sean MacGuire - The MacLawran Group Inc.
 * Version 1.09
 * Feb 2nd, 1999
 *
 * This program is Copyright (c) 1997-1999
 * The MacLawran Group Inc.
 * All Rights Reserved
 *
 * Create a file with the given name half an hour old...
 * Default creates a file 30 minutes old. (-30)
 *
 * Format: touchtime [offset-time] filename
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <utime.h>

#define NOYEAR 1		/* FOR NOW */
#define debug 	/* printf */

main(argc, argv)
int argc;
char *argv[];
{
	FILE *fp;
        time_t ticks;
	struct utimbuf *tb;
	int howlong;
	char *touchfile = (char *)malloc(256);

	if (argc == 3) {	
		sscanf(argv[1], "%d", &howlong);
		sscanf(argv[2], "%s", touchfile);
	}
	else if (argc == 2) {
		howlong = -30;		/* DEFAULT 30 MINUTES AGO */
		sscanf(argv[1], "%s", touchfile);
	}
	else {
		fprintf(stderr, "Format: %s [offset] filename\n", argv[0]);
		exit(1);
	}

	howlong *= 60;			/* NOW IN SECONDS */

        ticks = time(&ticks) + howlong;

	tb=(struct utimbuf *)malloc(sizeof (struct utimbuf));

	tb->actime=ticks;
	tb->modtime=ticks;

	/*
	 * NOW CREATE THE TOUCHFILE
	 * OR JUST CHANGE THE MODIFICATION TIME IF IT ALREADY EXISTS
	 */
	if (fp = fopen(touchfile, "a")){
		fclose(fp);
	}
	else {
		fprintf(stderr, "%s: Can't open filename %s\n", argv[0], touchfile);
		exit(2);
	}
	utime(touchfile, tb);

	exit(0);
}
